/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->shader->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 339 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_ABSNEG = 19,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 20,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 21,                     /* T_ABS  */
  YYSYMBOL_T_R = 22,                       /* T_R  */
  YYSYMBOL_T_HR = 23,                      /* T_HR  */
  YYSYMBOL_T_HC = 24,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 25,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 26,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 27,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 28,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 29,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 30,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 31,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 32,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 33,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 34,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 35,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 36,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 37,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 38,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 39,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 40,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 41,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 42,                      /* T_SY  */
  YYSYMBOL_T_SS = 43,                      /* T_SS  */
  YYSYMBOL_T_JP = 44,                      /* T_JP  */
  YYSYMBOL_T_SAT = 45,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 46,                     /* T_RPT  */
  YYSYMBOL_T_UL = 47,                      /* T_UL  */
  YYSYMBOL_T_NOP = 48,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 49,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 50,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 51,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 52,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 53,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 54,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 55,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 56,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 57,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 58,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 59,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 60,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 61,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 62,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 63,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 64,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 65,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 66,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 67,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 68,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 69,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 70,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 71,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETONE = 72,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 73,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 74,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 75,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 76,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 77,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 78,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 79,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 80,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 81,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 82,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 83,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 84,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 85,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 86,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 87,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 88,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 89,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 90,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 91,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 92,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 93,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 94,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 95,              /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 96,               /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 97,              /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 98,              /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 99,              /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 100,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 101,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 102,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 103,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 104,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 105,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 106,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 107,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 108,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 109,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 110,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 111,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 112,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 113,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 114,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 115,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 116,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 117,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 118,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 119,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 120,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 121,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 122,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 123,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 124,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 125,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 126,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_MGEN_B = 127,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 128,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 129,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 130,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 131,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 132,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 133,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 134,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 135,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 136,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 137,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 138,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 139,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 140,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 141,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 142,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 143,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 144,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 145,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 146,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 147,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 148,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHLG_B16 = 149,            /* T_OP_SHLG_B16  */
  YYSYMBOL_T_OP_RCP = 150,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 151,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 152,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 153,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 154,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 155,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 156,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 157,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 158,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 159,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 160,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 161,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 162,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 163,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 164,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 165,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 166,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 167,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 168,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 169,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 170,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 171,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 172,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 173,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 174,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 175,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 176,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 177,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 178,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 179,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 180,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 181,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 182,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 183,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 184,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 185,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 186,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 187,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_LDG = 188,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 189,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 190,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 191,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 192,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 193,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 194,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 195,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 196,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 197,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 198,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 199,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 200,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 201,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 202,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 203,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 204,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 205,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 206,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 207,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 208,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 209,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 210,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 211,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 212,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 213,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 214,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 215,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 216,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 217,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 218,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 219,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 220,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 221,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 222,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 223,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 224,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 225,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 226,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 227,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 228,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_LDGB = 229,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 230,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 231,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 232,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 233,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 234,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 235,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_BAR = 236,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 237,               /* T_OP_FENCE  */
  YYSYMBOL_T_TYPE_F16 = 238,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 239,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 240,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 241,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 242,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 243,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 244,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 245,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 246,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 247,                  /* T_TYPED  */
  YYSYMBOL_T_1D = 248,                     /* T_1D  */
  YYSYMBOL_T_2D = 249,                     /* T_2D  */
  YYSYMBOL_T_3D = 250,                     /* T_3D  */
  YYSYMBOL_T_4D = 251,                     /* T_4D  */
  YYSYMBOL_T_LT = 252,                     /* T_LT  */
  YYSYMBOL_T_LE = 253,                     /* T_LE  */
  YYSYMBOL_T_GT = 254,                     /* T_GT  */
  YYSYMBOL_T_GE = 255,                     /* T_GE  */
  YYSYMBOL_T_EQ = 256,                     /* T_EQ  */
  YYSYMBOL_T_NE = 257,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 258,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 259,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 260,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 261,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 262,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 263,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 264,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 265,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 266,                    /* T_NAN  */
  YYSYMBOL_T_INF = 267,                    /* T_INF  */
  YYSYMBOL_T_A0 = 268,                     /* T_A0  */
  YYSYMBOL_T_A1 = 269,                     /* T_A1  */
  YYSYMBOL_T_P0 = 270,                     /* T_P0  */
  YYSYMBOL_T_W = 271,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 272,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_273_ = 273,                     /* '-'  */
  YYSYMBOL_274_ = 274,                     /* ','  */
  YYSYMBOL_275_ = 275,                     /* '('  */
  YYSYMBOL_276_ = 276,                     /* ')'  */
  YYSYMBOL_277_ = 277,                     /* '='  */
  YYSYMBOL_278_ = 278,                     /* ':'  */
  YYSYMBOL_279_ = 279,                     /* '!'  */
  YYSYMBOL_280_ = 280,                     /* '#'  */
  YYSYMBOL_281_ = 281,                     /* '.'  */
  YYSYMBOL_282_a_ = 282,                   /* 'a'  */
  YYSYMBOL_283_o_ = 283,                   /* 'o'  */
  YYSYMBOL_284_p_ = 284,                   /* 'p'  */
  YYSYMBOL_285_s_ = 285,                   /* 's'  */
  YYSYMBOL_286_ = 286,                     /* '+'  */
  YYSYMBOL_287_ = 287,                     /* '<'  */
  YYSYMBOL_288_g_ = 288,                   /* 'g'  */
  YYSYMBOL_289_ = 289,                     /* '['  */
  YYSYMBOL_290_ = 290,                     /* ']'  */
  YYSYMBOL_291_l_ = 291,                   /* 'l'  */
  YYSYMBOL_292_w_ = 292,                   /* 'w'  */
  YYSYMBOL_293_r_ = 293,                   /* 'r'  */
  YYSYMBOL_294_ = 294,                     /* '>'  */
  YYSYMBOL_295_c_ = 295,                   /* 'c'  */
  YYSYMBOL_296_h_ = 296,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 297,                 /* $accept  */
  YYSYMBOL_shader = 298,                   /* shader  */
  YYSYMBOL_299_1 = 299,                    /* $@1  */
  YYSYMBOL_headers = 300,                  /* headers  */
  YYSYMBOL_header = 301,                   /* header  */
  YYSYMBOL_const_val = 302,                /* const_val  */
  YYSYMBOL_localsize_header = 303,         /* localsize_header  */
  YYSYMBOL_const_header = 304,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 305,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 306,               /* buf_header  */
  YYSYMBOL_307_2 = 307,                    /* $@2  */
  YYSYMBOL_invocationid_header = 308,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 309,              /* wgid_header  */
  YYSYMBOL_numwg_header = 310,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 311,       /* branchstack_header  */
  YYSYMBOL_in_header = 312,                /* in_header  */
  YYSYMBOL_out_header = 313,               /* out_header  */
  YYSYMBOL_tex_header = 314,               /* tex_header  */
  YYSYMBOL_iflag = 315,                    /* iflag  */
  YYSYMBOL_iflags = 316,                   /* iflags  */
  YYSYMBOL_instrs = 317,                   /* instrs  */
  YYSYMBOL_instr = 318,                    /* instr  */
  YYSYMBOL_label = 319,                    /* label  */
  YYSYMBOL_cat0_src1 = 320,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 321,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 322,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 323,               /* cat0_instr  */
  YYSYMBOL_324_3 = 324,                    /* $@3  */
  YYSYMBOL_325_4 = 325,                    /* $@4  */
  YYSYMBOL_326_5 = 326,                    /* $@5  */
  YYSYMBOL_327_6 = 327,                    /* $@6  */
  YYSYMBOL_328_7 = 328,                    /* $@7  */
  YYSYMBOL_329_8 = 329,                    /* $@8  */
  YYSYMBOL_330_9 = 330,                    /* $@9  */
  YYSYMBOL_331_10 = 331,                   /* $@10  */
  YYSYMBOL_332_11 = 332,                   /* $@11  */
  YYSYMBOL_333_12 = 333,                   /* $@12  */
  YYSYMBOL_334_13 = 334,                   /* $@13  */
  YYSYMBOL_335_14 = 335,                   /* $@14  */
  YYSYMBOL_336_15 = 336,                   /* $@15  */
  YYSYMBOL_337_16 = 337,                   /* $@16  */
  YYSYMBOL_338_17 = 338,                   /* $@17  */
  YYSYMBOL_cat1_opc = 339,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 340,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 341,              /* cat1_movmsk  */
  YYSYMBOL_342_18 = 342,                   /* $@18  */
  YYSYMBOL_cat1_mova1 = 343,               /* cat1_mova1  */
  YYSYMBOL_344_19 = 344,                   /* $@19  */
  YYSYMBOL_cat1_mova = 345,                /* cat1_mova  */
  YYSYMBOL_346_20 = 346,                   /* $@20  */
  YYSYMBOL_cat1_swz = 347,                 /* cat1_swz  */
  YYSYMBOL_348_21 = 348,                   /* $@21  */
  YYSYMBOL_cat1_gat = 349,                 /* cat1_gat  */
  YYSYMBOL_350_22 = 350,                   /* $@22  */
  YYSYMBOL_cat1_sct = 351,                 /* cat1_sct  */
  YYSYMBOL_352_23 = 352,                   /* $@23  */
  YYSYMBOL_cat1_instr = 353,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 354,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 355,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 356,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 357,                     /* cond  */
  YYSYMBOL_cat2_instr = 358,               /* cat2_instr  */
  YYSYMBOL_cat3_opc = 359,                 /* cat3_opc  */
  YYSYMBOL_cat3_instr = 360,               /* cat3_instr  */
  YYSYMBOL_361_24 = 361,                   /* $@24  */
  YYSYMBOL_cat4_opc = 362,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 363,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 364,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 365,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 366,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 367,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 368,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 369,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 370,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 371,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 372,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 373,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 374,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 375,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 376,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 377,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 378,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 379,               /* cat6_immed  */
  YYSYMBOL_cat6_stg_ldg_a6xx_offset = 380, /* cat6_stg_ldg_a6xx_offset  */
  YYSYMBOL_cat6_load = 381,                /* cat6_load  */
  YYSYMBOL_382_25 = 382,                   /* $@25  */
  YYSYMBOL_383_26 = 383,                   /* $@26  */
  YYSYMBOL_384_27 = 384,                   /* $@27  */
  YYSYMBOL_385_28 = 385,                   /* $@28  */
  YYSYMBOL_386_29 = 386,                   /* $@29  */
  YYSYMBOL_387_30 = 387,                   /* $@30  */
  YYSYMBOL_388_31 = 388,                   /* $@31  */
  YYSYMBOL_cat6_store = 389,               /* cat6_store  */
  YYSYMBOL_390_32 = 390,                   /* $@32  */
  YYSYMBOL_391_33 = 391,                   /* $@33  */
  YYSYMBOL_392_34 = 392,                   /* $@34  */
  YYSYMBOL_393_35 = 393,                   /* $@35  */
  YYSYMBOL_394_36 = 394,                   /* $@36  */
  YYSYMBOL_cat6_storeib = 395,             /* cat6_storeib  */
  YYSYMBOL_396_37 = 396,                   /* $@37  */
  YYSYMBOL_cat6_prefetch = 397,            /* cat6_prefetch  */
  YYSYMBOL_398_38 = 398,                   /* $@38  */
  YYSYMBOL_cat6_atomic_opc = 399,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_atomic_g = 400,            /* cat6_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 401,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 402,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 403,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 404,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 405,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 406,                 /* cat6_ibo  */
  YYSYMBOL_407_39 = 407,                   /* $@39  */
  YYSYMBOL_cat6_id_opc = 408,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 409,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 410,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 411,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 412,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 413, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 414, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 415, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 416,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 417,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc = 418,        /* cat6_bindless_ldc  */
  YYSYMBOL_cat6_todo = 419,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 420,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 421,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 422,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 423,             /* cat7_barrier  */
  YYSYMBOL_424_40 = 424,                   /* $@40  */
  YYSYMBOL_425_41 = 425,                   /* $@41  */
  YYSYMBOL_cat7_instr = 426,               /* cat7_instr  */
  YYSYMBOL_src = 427,                      /* src  */
  YYSYMBOL_dst = 428,                      /* dst  */
  YYSYMBOL_const = 429,                    /* const  */
  YYSYMBOL_dst_reg_flag = 430,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 431,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 432,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 433,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 434,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 435,                  /* src_reg  */
  YYSYMBOL_src_const = 436,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 437,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 438,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 439, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 440,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 441,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 442,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 443,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 444,           /* relative_const  */
  YYSYMBOL_relative = 445,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 446,           /* immediate_cat1  */
  YYSYMBOL_immediate = 447,                /* immediate  */
  YYSYMBOL_flut_immed = 448,               /* flut_immed  */
  YYSYMBOL_integer = 449,                  /* integer  */
  YYSYMBOL_float = 450,                    /* float  */
  YYSYMBOL_type = 451                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 307 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 835 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1221

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  297
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  155
/* YYNRULES -- Number of rules.  */
#define YYNRULES  475
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  994

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   527


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   279,     2,   280,     2,     2,     2,     2,
     275,   276,     2,   286,   274,   273,   281,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   278,     2,
     287,   277,   294,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   289,     2,   290,     2,     2,     2,   282,     2,   295,
       2,     2,     2,   288,   296,     2,     2,     2,   291,     2,
       2,   283,   284,     2,   293,   285,     2,     2,     2,   292,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   643,   643,   643,   645,   646,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   659,   660,   661,   662,
     664,   670,   674,   675,   684,   684,   690,   696,   703,   711,
     714,   716,   718,   725,   726,   727,   728,   729,   730,   731,
     733,   734,   736,   737,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   749,   751,   752,   754,   755,   757,   758,
     760,   761,   761,   762,   762,   763,   763,   764,   764,   765,
     765,   766,   766,   767,   767,   768,   768,   769,   769,   770,
     771,   771,   772,   773,   774,   775,   776,   777,   778,   778,
     779,   780,   781,   782,   783,   783,   784,   785,   785,   786,
     787,   787,   788,   788,   789,   791,   794,   798,   799,   801,
     801,   810,   810,   817,   817,   824,   824,   826,   826,   828,
     828,   831,   832,   833,   834,   835,   836,   837,   838,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   855,   856,   857,   858,   859,   860,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   889,   890,   891,   892,   893,
     894,   896,   897,   898,   900,   901,   902,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     917,   918,   918,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   931,   933,   934,   936,   937,   938,   939,
     940,   941,   942,   943,   944,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   974,   975,   976,   977,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   995,   996,   998,   999,  1000,  1001,  1003,  1004,  1005,
    1006,  1007,  1008,  1010,  1013,  1018,  1024,  1024,  1025,  1025,
    1026,  1026,  1027,  1027,  1028,  1028,  1029,  1029,  1029,  1036,
    1036,  1037,  1037,  1038,  1038,  1039,  1039,  1040,  1040,  1042,
    1042,  1044,  1044,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1058,  1062,  1064,  1065,  1067,  1069,
    1070,  1072,  1073,  1074,  1074,  1077,  1078,  1080,  1082,  1083,
    1085,  1086,  1087,  1089,  1090,  1092,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1107,  1109,
    1110,  1111,  1113,  1115,  1122,  1123,  1124,  1126,  1127,  1128,
    1129,  1130,  1131,  1132,  1133,  1134,  1135,  1137,  1138,  1139,
    1140,  1142,  1143,  1145,  1145,  1146,  1146,  1148,  1150,  1151,
    1152,  1153,  1155,  1156,  1157,  1158,  1160,  1162,  1163,  1164,
    1165,  1166,  1168,  1169,  1172,  1173,  1175,  1176,  1177,  1178,
    1180,  1181,  1183,  1184,  1186,  1187,  1189,  1190,  1192,  1193,
    1194,  1196,  1197,  1198,  1200,  1201,  1202,  1204,  1205,  1206,
    1208,  1209,  1211,  1212,  1214,  1215,  1217,  1218,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1232,  1233,  1234,  1235,  1236,
    1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,
    1249,  1250,  1252,  1253,  1254,  1255,  1257,  1258,  1260,  1261,
    1262,  1263,  1264,  1265,  1266,  1267
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_ABSNEG", "T_NEG",
  "T_ABS", "T_R", "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY",
  "T_NEG_INFINITY", "T_EI", "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5",
  "T_FLUT_1_0", "T_FLUT_2_0", "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI",
  "T_FLUT_INV_LOG2_E", "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10",
  "T_FLUT_LOG2_10", "T_FLUT_4_0", "T_SY", "T_SS", "T_JP", "T_SAT", "T_RPT",
  "T_UL", "T_NOP", "T_OP_NOP", "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA",
  "T_OP_BRAC", "T_OP_BANY", "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP",
  "T_OP_CALL", "T_OP_RET", "T_OP_KILL", "T_OP_END", "T_OP_EMIT",
  "T_OP_CUT", "T_OP_CHMASK", "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT",
  "T_OP_STKS", "T_OP_STKR", "T_OP_XSET", "T_OP_XCLR", "T_OP_GETONE",
  "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF",
  "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV",
  "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_MGEN_B", "T_OP_GETBIT_B",
  "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD", "T_OP_MAD_U16",
  "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16", "T_OP_MAD_U24",
  "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32", "T_OP_SEL_B16",
  "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32", "T_OP_SEL_F16",
  "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32", "T_OP_SHLG_B16",
  "T_OP_RCP", "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_LDG", "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG",
  "T_OP_STG_A", "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L",
  "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT",
  "T_OP_RESINFO", "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC", "T_OP_LDLV",
  "T_OP_GETSPID", "T_OP_GETWID", "T_OP_BAR", "T_OP_FENCE", "T_TYPE_F16",
  "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32",
  "T_TYPE_U8", "T_TYPE_S8", "T_UNTYPED", "T_TYPED", "T_1D", "T_2D", "T_3D",
  "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN",
  "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM",
  "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "'-'", "','", "'('", "')'", "'='", "':'", "'!'",
  "'#'", "'.'", "'a'", "'o'", "'p'", "'s'", "'+'", "'<'", "'g'", "'['",
  "']'", "'l'", "'w'", "'r'", "'>'", "'c'", "'h'", "$accept", "shader",
  "$@1", "headers", "header", "const_val", "localsize_header",
  "const_header", "buf_header_addr_reg", "buf_header", "$@2",
  "invocationid_header", "wgid_header", "numwg_header",
  "branchstack_header", "in_header", "out_header", "tex_header", "iflag",
  "iflags", "instrs", "instr", "label", "cat0_src1", "cat0_src2",
  "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17",
  "cat1_opc", "cat1_src", "cat1_movmsk", "$@18", "cat1_mova1", "$@19",
  "cat1_mova", "$@20", "cat1_swz", "$@21", "cat1_gat", "$@22", "cat1_sct",
  "$@23", "cat1_instr", "cat2_opc_1src", "cat2_opc_2src_cnd",
  "cat2_opc_2src", "cond", "cat2_instr", "cat3_opc", "cat3_instr", "$@24",
  "cat4_opc", "cat4_instr", "cat5_opc_dsxypp", "cat5_opc", "cat5_flag",
  "cat5_flags", "cat5_samp", "cat5_tex", "cat5_type", "cat5_a1",
  "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset",
  "cat6_offset", "cat6_dst_offset", "cat6_immed",
  "cat6_stg_ldg_a6xx_offset", "cat6_load", "$@25", "$@26", "$@27", "$@28",
  "$@29", "$@30", "$@31", "cat6_store", "$@32", "$@33", "$@34", "$@35",
  "$@36", "cat6_storeib", "$@37", "cat6_prefetch", "$@38",
  "cat6_atomic_opc", "cat6_atomic_g", "cat6_atomic_l", "cat6_atomic",
  "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb", "cat6_ibo_opc_stgb",
  "cat6_ibo", "$@39", "cat6_id_opc", "cat6_id", "cat6_bindless_base",
  "cat6_bindless_mode", "cat6_reg_or_immed", "cat6_bindless_ibo_opc_1src",
  "cat6_bindless_ibo_opc_2src", "cat6_bindless_ibo_opc_2src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc",
  "cat6_todo", "cat6_instr", "cat7_scope", "cat7_scopes", "cat7_barrier",
  "$@40", "$@41", "cat7_instr", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_const", "src_reg_or_const", "src_reg_or_const_or_rel",
  "src_reg_or_const_or_rel_or_imm", "src_reg_or_rel_or_imm", "offset",
  "relative_gpr_src", "relative_gpr_dst", "relative_const", "relative",
  "immediate_cat1", "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,    45,    44,    40,    41,    61,    58,    33,
      35,    46,    97,   111,   112,   115,    43,    60,   103,    91,
      93,   108,   119,   114,    62,    99,   104
};
#endif

#define YYPACT_NINF (-744)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-44)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -744,    35,   855,  -744,    34,  -256,    34,  -230,  -219,  -195,
      34,  -183,  -180,  -170,   758,   855,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,   108,
    -156,   121,  -744,   143,   147,   153,  -744,   159,   166,   173,
     -90,  -744,  -744,  -744,  -744,  -744,  -744,  -744,   840,   984,
    -744,   815,  -744,  -744,  -744,    34,   -85,   -82,   -74,   -68,
     -67,   -63,   -60,   -57,  -744,  -744,  -744,  -744,  -744,  -744,
     -61,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,   -56,   -43,   -39,   -51,
     -45,   -44,   -41,   -40,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,   439,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,    99,   -37,    99,  -744,    99,  -744,    99,
    -744,   -36,   -36,  -744,  -744,  -744,  -744,  -744,   -34,  -744,
    -744,  -744,   -33,   -34,   -34,  -744,   -33,  -744,   -34,   -34,
     -34,  -744,   -21,  -744,  -744,  -744,  -744,  -744,  -744,   -13,
      34,   255,  -744,  -744,  -744,  -744,   258,   271,   273,  -216,
    -216,  -216,    19,  -216,  -216,     7,     7,     7,  -216,     7,
       7,     7,  -216,  -216,    24,    26,    58,    36,    39,    61,
      68,    69,    99,   -33,   -33,   -33,   -33,   -33,   -33,   -33,
     -33,    10,   -33,   -33,   -34,   -33,    28,    28,  -744,    57,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,    62,  -744,
     579,   228,    76,    81,    87,   374,    92,    98,   106,  -214,
     -36,    99,   112,  -174,   100,   636,   100,   100,   100,    99,
     100,   100,   100,   130,    34,   109,   120,   122,   123,   131,
    -744,   137,   140,   142,   145,  -744,  -744,   111,  -744,   150,
     158,    37,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,   163,
      99,    99,    99,    99,   129,   139,   149,   160,   144,    99,
     154,   100,    99,  -204,    28,  -744,  -744,   183,   184,  -744,
    -744,    78,    78,   282,  -744,  -744,  -744,  -744,  -744,  -744,
      99,   282,   435,   282,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,   196,   636,    99,  -744,  -744,     5,   -33,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,    99,
     -33,   -33,  -744,   -33,   -33,   -33,   202,  -744,    34,  -744,
     447,   471,    19,  -744,     7,  -176,  -176,  -744,  -744,     7,
       7,     7,  -744,  -744,    99,    78,    78,    99,    99,    99,
     652,   211,   212,   217,   219,   205,   206,   218,   222,   245,
     238,   227,   -33,   243,  -744,  -744,  -744,  -744,  -744,  -222,
    -222,  -744,  -744,  -744,  -744,  -744,  -744,   236,   237,  -744,
    -744,  -744,   155,   239,   240,   234,  -744,  -744,  -744,   262,
     125,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,    19,   721,   235,  -744,  -744,  -744,  -744,
    -744,   248,   261,   264,  -744,   499,   253,   265,  -744,  -744,
    -744,  -744,   259,   268,   266,   267,   272,   275,   277,    19,
     269,   285,   286,   290,  -744,  -744,   289,   292,   294,  -744,
    -744,  -744,  -744,  -744,  -744,   296,   298,   299,   245,  -744,
     300,  -744,  -744,   288,   291,   302,   303,   245,   245,   245,
     245,  -190,   304,   245,   301,   309,    19,    19,   308,   316,
     312,   326,  -744,   336,   339,   172,   340,   341,   350,   351,
      54,  -744,  -744,  -744,  -744,   345,    19,  -744,  -744,   282,
     282,   453,  -744,  -744,   179,    19,   334,    19,    19,    19,
      19,    19,   342,  -744,    34,    19,    19,   618,  -744,     7,
       7,    99,   499,    99,   453,   346,   349,   352,   354,  -222,
     348,  -182,  -182,   116,  -744,   355,  -744,   357,  -182,    19,
     358,  -744,  -744,  -744,  -744,  -222,  -222,  -744,  -744,  -744,
    -744,  -744,  -222,  -222,   363,   364,  -744,   368,   375,  -744,
     220,   376,  -744,  -744,   377,  -744,   378,   373,   371,    99,
    -744,   380,   381,   382,    65,   383,   388,   389,   390,  -744,
    -744,   395,   396,   403,   404,   245,   245,   245,   245,   391,
     161,   405,   116,   406,  -744,   410,  -744,   436,   245,   422,
     425,    19,   385,   420,   421,   423,  -744,  -744,  -744,   282,
     435,   458,   179,  -226,   116,   445,   432,    65,    65,    65,
     444,   444,   444,    99,    34,  -744,  -744,    19,   499,   499,
      99,   652,  -190,   348,  -190,  -190,   452,   245,   440,   455,
    -744,   457,   460,    19,  -190,   464,   450,   451,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,   468,  -744,   470,    99,    99,
     473,  -744,  -744,   478,   481,    99,   499,    99,   511,  -744,
    -744,  -744,   497,  -744,   500,   502,   503,   505,  -744,   483,
     490,   491,   492,   245,  -222,   496,   245,   245,   245,  -744,
     517,   245,   104,  -744,   480,   179,   512,   513,  -744,   501,
     116,   518,   519,   534,  -744,   116,   805,   499,   499,    99,
     538,   539,   540,   543,   544,   546,    19,   545,   549,   553,
     554,   556,   541,   558,  -744,  -744,  -744,   560,  -744,  -744,
     547,   548,   116,   550,   116,   116,   116,   563,   561,  -744,
     568,   577,   104,   104,   104,   104,   104,   567,  -222,   104,
     104,   104,   104,   104,   582,   104,   458,   600,   601,   602,
     617,  -744,   619,   620,   116,    19,   499,   499,  -744,  -744,
    -744,  -744,  -744,   608,   609,  -744,  -744,  -744,  -744,  -744,
     245,  -744,  -744,   116,   116,   623,   245,   116,   116,  -744,
     624,  -744,  -744,    19,   612,   626,   611,   613,   245,   628,
    -744,  -744,   898,  -744,    19,   245,   631,   632,   633,   116,
     634,  -744,   635,   245,   245,   245,   638,    19,   245,   639,
    -744,  -744,   245,   640,  -744,   245,  -744,   902,   641,   642,
     245,    19,  -744,  -744
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    40,     4,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    17,    19,    16,     0,
       0,     0,    24,     0,     0,     0,    29,     0,     0,     0,
       0,    33,    34,    35,    36,    37,    38,    39,    40,     0,
       3,    40,    52,     5,    18,     0,     0,    22,     0,     0,
       0,     0,     0,     0,    53,    41,    60,    61,    63,    65,
       0,    69,    71,    73,    75,    77,    79,    80,    82,    83,
      84,    85,    86,    87,    88,    90,    91,    92,    93,    94,
      96,    97,    99,   100,   102,   104,     0,     0,     0,     0,
       0,     0,     0,     0,   149,   150,   151,   152,   133,   143,
     129,   146,   134,   135,   136,   137,   138,   153,   154,   155,
     156,   144,   145,   157,   158,   159,   160,   130,   161,   162,
     139,   163,   147,   148,   164,   165,   166,   140,   132,   131,
     167,   168,   169,   170,   171,   172,   141,   142,   173,   174,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   201,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   214,   215,   240,   241,   286,   288,   292,   290,   299,
     301,   305,   303,   364,   365,   311,   294,   307,   366,   328,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   345,   358,   357,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   329,   330,   309,   362,   296,
     335,   336,   383,   385,    44,     0,   121,   122,   123,   124,
     125,   126,    45,     0,     0,     0,    46,     0,    47,     0,
      48,   250,   250,    49,   367,   368,   369,   370,     0,   326,
     327,   371,     0,     0,     0,   372,     0,   373,     0,     0,
       0,   375,     0,   374,   376,    50,   387,    51,    42,     0,
       0,     0,    25,    26,    27,    28,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   381,   381,   392,     0,
     397,   398,   399,   400,   401,   393,   394,   395,     0,   404,
     402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     250,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,     0,     0,     0,     0,   462,   464,     0,    67,     0,
       0,     0,    74,    76,    78,    81,    89,    95,    98,   101,
     103,   109,   111,   113,   105,   106,   115,   117,   119,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   381,   384,   386,     0,     0,   403,
     405,     0,     0,     0,   175,   176,   177,   178,   179,   180,
       0,     0,     0,     0,   242,   247,   249,   248,   243,   244,
     245,   246,   251,     0,     0,     0,   271,   272,     0,     0,
     468,   469,   470,   471,   472,   473,   474,   475,   277,     0,
       0,     0,   337,     0,     0,     0,     0,    20,     0,    23,
       0,     0,     0,    54,     0,     0,     0,   463,   465,     0,
       0,     0,    59,    58,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   380,   379,   377,   378,   382,   427,
     427,   388,   396,   406,   407,   408,   409,     0,     0,   389,
     390,   391,     0,     0,     0,     0,   127,   412,   414,   410,
       0,   416,   417,   418,   107,   436,   437,   419,   108,   438,
     128,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,     0,     0,   421,   181,   423,   447,
     445,     0,     0,     0,   213,     0,     0,   270,   273,   274,
     275,   276,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    62,    57,     0,     0,     0,    68,
      70,    72,   110,   112,   114,     0,     0,     0,     0,   424,
       0,   425,   426,     0,     0,     0,     0,     0,     0,     0,
       0,   427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,     0,     0,     0,     0,     0,     0,     0,
       0,   411,   413,   415,   420,     0,     0,   449,   422,     0,
       0,     0,   256,   254,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   283,     0,     0,     0,     0,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   427,
       0,   427,   427,     0,   279,     0,   278,     0,   427,     0,
       0,   429,   428,   433,   432,   427,   427,   443,   444,   467,
     439,   440,   427,   427,     0,     0,   446,     0,     0,   183,
       0,     0,   252,   253,   268,   269,   266,     0,     0,     0,
     333,     0,     0,     0,     0,     0,     0,     0,     0,    64,
      66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   281,     0,   280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   441,   442,   448,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     338,   338,   338,     0,     0,    30,    31,     0,     0,     0,
       0,     0,   427,     0,   427,   427,     0,     0,     0,     0,
     282,     0,     0,     0,   427,     0,     0,     0,   431,   435,
     430,   434,   182,   200,   267,   264,   265,   261,     0,     0,
       0,   343,   344,     0,     0,     0,     0,     0,     0,   341,
     342,   340,     0,    21,     0,     0,     0,     0,   202,     0,
       0,     0,     0,     0,   427,     0,     0,     0,     0,   312,
       0,     0,     0,   297,     0,     0,     0,     0,   331,     0,
       0,     0,     0,     0,   339,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   262,   263,   255,   259,   260,   257,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   116,
       0,     0,     0,     0,     0,     0,     0,     0,   427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   359,     0,     0,     0,     0,     0,     0,   287,   289,
     293,   291,   300,     0,     0,   302,   306,   304,   295,   308,
       0,   298,   258,     0,     0,     0,     0,     0,     0,   363,
       0,   118,   120,     0,     0,     0,     0,     0,     0,     0,
     360,   361,     0,   284,     0,     0,     0,     0,     0,     0,
       0,   285,     0,     0,     0,     0,     0,     0,     0,     0,
     325,   332,     0,     0,   310,     0,   334,     0,     0,     0,
       0,     0,   324,    32
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -744,  -744,  -744,   895,  -744,    -6,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,   868,
     866,  -744,  -744,   223,   427,  -289,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -396,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -224,  -743,  -738,  -744,  -744,  -744,   -66,  -225,   510,   229,
    -625,  -637,   -79,   133,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -597,  -441,  -159,  -744,  -744,  -744,  -744,
    -744,  -744,  -744,  -744,  -744,  -287,  -744,  -744,  -744,  -744,
    -149,   569,  -533,  -744,   564,  -258,  -744,  -427,  -492,  -744,
    -608,  -439,  -445,   138,  -509,  -744,  -744,  -744,  -498,  -744,
    -500,   359,  -311,   278,   467
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    14,    15,    30,    16,    17,   302,    18,
      57,    19,    20,    21,    22,    23,    24,    25,    48,    49,
      50,    51,    52,   392,   607,   402,   254,   309,   310,   311,
     499,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   255,   546,   256,   504,   257,   505,   258,   506,
     259,   507,   260,   508,   261,   509,   262,   263,   264,   265,
     450,   266,   267,   268,   332,   269,   270,   271,   272,   370,
     371,   724,   725,   465,   885,   273,   374,   469,   376,   694,
     695,   753,   672,   751,   274,   333,   334,   336,   335,   342,
     345,   883,   275,   337,   338,   340,   339,   343,   276,   344,
     277,   341,   278,   279,   280,   281,   282,   283,   284,   285,
     776,   286,   287,   829,   783,   820,   288,   289,   290,   291,
     292,   293,   294,   295,   434,   435,   296,   346,   347,   297,
     547,   359,   548,   360,   361,   362,   549,   618,   551,   552,
     553,   576,   577,   620,   696,   555,   363,   556,   557,   558,
     578,   579,   580,   647,   478
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      32,   398,   554,   554,    36,   364,   582,   366,   584,   367,
     622,   368,   621,   583,   550,   550,   575,   653,   619,    31,
     638,   639,   395,   396,   575,   550,   575,   403,   404,   815,
     406,   407,   408,   814,   816,     3,   454,    26,    27,    28,
     395,   396,   653,   502,   455,    33,   560,   456,   372,   299,
     457,   636,   654,   721,   390,   755,    34,   395,   396,   642,
     436,   759,   818,   391,   637,   819,   554,   554,   458,   459,
     460,   461,   466,   467,   419,   658,   744,   654,   550,   550,
      35,   395,   396,   636,   524,   531,   532,   525,   526,   527,
     503,   636,    37,   662,   605,    38,   693,   533,   534,   535,
     536,   537,   538,   606,   752,    39,   348,   395,   396,   613,
     614,    54,   887,   463,   497,   498,   884,   888,    55,   395,
     396,   482,   651,   531,   350,   351,   352,   353,   354,    56,
     559,   559,   531,   532,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   462,   528,   537,   538,
      58,   479,   480,   481,    59,   483,   484,   485,   395,   396,
     642,    60,   511,   512,   513,   514,    61,   839,   531,   841,
     842,   520,   726,    62,   523,   497,   498,   709,   942,   850,
      63,   603,   754,   754,   830,   831,   531,   653,    64,   754,
     742,   300,   581,   301,   559,   559,   762,   763,   533,   534,
     535,   536,   303,   764,   765,   604,   522,   587,   304,   305,
     609,   610,   611,   306,   718,   719,   307,   377,   378,   308,
     312,   593,   380,   381,   382,   324,   325,   531,   532,   326,
     327,   646,   575,   575,   720,   348,   328,   329,   395,   396,
     330,   331,   531,   532,   365,   369,   612,   373,   375,   615,
     616,   617,   531,   588,   589,   590,   591,   720,   537,   538,
     383,   384,   655,   386,   387,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   388,   431,   389,
     817,   533,   534,   535,   536,   395,   396,   401,   673,   531,
     532,   622,   397,   621,   385,   411,   835,   836,   428,   619,
     412,   533,   534,   535,   536,   537,   538,    29,   414,   433,
     397,   415,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   812,   701,   702,   645,   780,   781,
     782,   813,   413,   416,   862,   875,   825,   826,   827,   714,
     417,   418,   575,   550,   437,   717,   539,   540,   541,   438,
     441,   397,   882,   542,   673,   442,   673,   673,   673,   673,
     673,   443,   886,   889,   736,   737,   451,   355,   356,   357,
     631,   543,   452,   544,   545,   899,   900,   397,   487,   573,
     453,   468,   702,   488,   539,   540,   541,   464,   673,   397,
     739,   740,   486,   539,   540,   541,   489,   490,   491,   934,
     574,   652,   928,   929,   930,   931,   932,   493,   492,   935,
     936,   937,   938,   939,   494,   941,   495,   515,   543,   496,
     544,   643,   644,   741,   500,   743,   652,   516,   645,   539,
     540,   541,   501,   519,   951,   952,   797,   510,   722,   723,
     517,   702,   531,   532,   518,   521,   348,   539,   540,   541,
     807,   529,   530,   601,   533,   534,   535,   536,   537,   538,
     531,   532,   349,   822,   350,   351,   352,   353,   354,   652,
     585,   775,   533,   534,   535,   536,   834,   602,   689,   690,
     691,   692,   600,   599,   698,   623,   624,   531,   539,   540,
     541,   625,   673,   626,   627,   628,   355,   356,   357,   533,
     534,   535,   536,   539,   540,   541,   531,   629,   397,   650,
     573,   630,   632,   539,   540,   541,   633,   635,   533,   534,
     535,   536,   659,   640,   641,   832,   648,   649,   543,   663,
     544,   574,   837,   393,   394,   660,   399,   400,   661,   664,
     665,   405,   666,   674,   756,   409,   410,   667,   668,   822,
     539,   540,   541,   669,   822,   397,   670,   573,   671,   678,
     856,   857,   675,   676,   677,   908,   679,   861,   680,   863,
     681,   652,   682,   683,   684,   543,   685,   544,   574,   686,
     705,   822,   699,   822,   822,   822,   727,   688,   729,   730,
     731,   732,   733,   687,   706,   697,   792,   793,   794,   795,
     700,   798,   703,   800,   350,   351,   352,   353,   354,   804,
     704,   901,   707,   822,   950,   708,   710,   711,   712,   713,
     760,   716,   728,   734,   738,   821,   444,   445,   446,   447,
     448,   449,   822,   822,   750,   745,   822,   822,   746,   766,
     767,   747,   963,   748,   768,   757,   758,   761,   844,   769,
     770,   771,   772,   971,   773,   395,   396,   784,   822,   531,
     774,   777,   778,   779,   785,   786,   983,   787,   735,   788,
     789,   533,   534,   535,   536,   537,   538,   790,   791,   808,
     993,   796,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   874,   799,   801,   877,   878,   879,
     802,   893,   881,   539,   540,   541,   897,   355,   356,   357,
     803,   821,   805,   806,   809,   810,   821,   811,   723,   823,
     824,   539,   540,   541,   849,   828,   843,   845,   543,   846,
     544,   847,   358,   919,   848,   921,   922,   923,   851,   852,
     723,   853,   854,   821,   855,   821,   821,   821,   539,   540,
     541,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   858,    40,   949,   859,   539,   540,   541,
     860,   865,   864,   870,   866,   821,   867,   868,   833,   869,
     871,   872,   873,   876,   956,   957,   890,   891,   960,   961,
     892,   955,   894,   895,   821,   821,   379,   959,   821,   821,
      41,    42,    43,    44,    45,    46,    47,   880,   896,   968,
     976,   898,   902,   903,   904,   -43,   972,   905,   906,   909,
     821,    40,   907,   910,   979,   980,   981,   911,   912,   984,
     913,   914,   915,   986,   916,   917,   988,   924,   925,   918,
     920,   992,   926,   420,   421,   422,   423,   424,   425,   426,
     427,   927,   429,   430,   933,   432,   940,    41,    42,    43,
      44,    45,    46,    47,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,   470,   471,   472,   473,   474,   475,
     476,   477,    41,    42,    43,    44,    45,    46,    47,   943,
     944,   946,   945,   947,   948,   953,   954,   958,   962,   964,
     965,   966,   969,   967,   970,   973,   974,   975,   989,   978,
      53,   977,   982,   985,   987,   990,    65,   298,   749,   991,
     539,   540,   541,   608,   439,   397,   840,   573,   715,   838,
     440,   586,     0,   657,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   543,     0,   544,   574,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   592,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     594,   595,     0,   596,   597,   598,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   634,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
       0,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253
};

static const yytype_int16 yycheck[] =
{
       6,   312,   441,   442,    10,   263,   451,   265,   453,   267,
     510,   269,   510,   452,   441,   442,   443,   550,   510,   275,
     529,   530,     3,     4,   451,   452,   453,   316,   317,   772,
     319,   320,   321,   771,   772,     0,   250,     3,     4,     5,
       3,     4,   575,     6,   258,   275,   442,   261,   272,    55,
     264,   273,   550,   661,   270,   692,   275,     3,     4,     5,
     347,   698,   288,   279,   286,   291,   505,   506,   282,   283,
     284,   285,   246,   247,   332,   575,   684,   575,   505,   506,
     275,     3,     4,   273,   288,     7,     8,   291,   292,   293,
     401,   273,   275,   585,   270,   275,   286,    19,    20,    21,
      22,    23,    24,   279,   286,   275,     7,     3,     4,   505,
     506,     3,   855,   371,     3,     4,   854,   855,   274,     3,
       4,   379,   549,     7,    25,    26,    27,    28,    29,     8,
     441,   442,     7,     8,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,   370,   434,    23,    24,
       7,   376,   377,   378,     7,   380,   381,   382,     3,     4,
       5,     8,   420,   421,   422,   423,     7,   792,     7,   794,
     795,   429,   664,     7,   432,     3,     4,     5,   916,   804,
       7,   492,   691,   692,   781,   782,     7,   720,   278,   698,
     682,   276,   450,   275,   505,   506,   705,   706,    19,    20,
      21,    22,   276,   712,   713,   494,   431,   465,   276,   276,
     499,   500,   501,   276,   659,   660,   276,   283,   284,   276,
     281,   479,   288,   289,   290,   281,   269,     7,     8,   268,
     281,   542,   659,   660,   661,     7,   281,   281,     3,     4,
     281,   281,     7,     8,   281,   281,   504,   281,   281,   507,
     508,   509,     7,   248,   249,   250,   251,   684,    23,    24,
     281,   274,   573,     8,     6,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,     6,   344,     6,
     772,    19,    20,    21,    22,     3,     4,   280,   599,     7,
       8,   791,   273,   791,   300,   271,   788,   789,   288,   791,
     274,    19,    20,    21,    22,    23,    24,   273,   272,   281,
     273,   272,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,   769,   636,   637,   273,   263,   264,
     265,   770,   274,   272,   826,   844,   777,   778,   779,   650,
     272,   272,   769,   770,   287,   656,   268,   269,   270,   287,
     274,   273,   852,   275,   665,   274,   667,   668,   669,   670,
     671,   274,   854,   855,   675,   676,   274,   268,   269,   270,
     519,   293,   274,   295,   296,   867,   868,   273,   384,   275,
     274,   281,   693,   274,   268,   269,   270,   275,   699,   273,
     679,   680,   262,   268,   269,   270,   276,   275,   275,   908,
     296,   550,   902,   903,   904,   905,   906,   270,   277,   909,
     910,   911,   912,   913,   274,   915,   274,   288,   293,   274,
     295,   266,   267,   681,   274,   683,   575,   288,   273,   268,
     269,   270,   274,   289,   926,   927,   275,   274,   259,   260,
     291,   752,     7,     8,   284,   291,     7,   268,   269,   270,
     761,   268,   268,     6,    19,    20,    21,    22,    23,    24,
       7,     8,    23,   774,    25,    26,    27,    28,    29,   618,
     274,   729,    19,    20,    21,    22,   787,     6,   627,   628,
     629,   630,   488,   281,   633,   274,   274,     7,   268,   269,
     270,   274,   803,   274,   289,   289,   268,   269,   270,    19,
      20,    21,    22,   268,   269,   270,     7,   289,   273,   275,
     275,   289,   274,   268,   269,   270,   289,   274,    19,    20,
      21,    22,   274,   287,   287,   783,   287,   287,   293,   276,
     295,   296,   790,   310,   311,   274,   313,   314,   274,   274,
     281,   318,   274,   274,   693,   322,   323,   281,   281,   860,
     268,   269,   270,   281,   865,   273,   281,   275,   281,   270,
     818,   819,   277,   277,   274,   876,   274,   825,   274,   827,
     274,   720,   274,   274,   274,   293,   288,   295,   296,   288,
     268,   892,   281,   894,   895,   896,   665,   284,   667,   668,
     669,   670,   671,   291,   268,   291,   745,   746,   747,   748,
     291,   750,   294,   752,    25,    26,    27,    28,    29,   758,
     294,   869,   276,   924,   925,   276,   276,   276,   268,   268,
     699,   276,   288,   281,     6,   774,   252,   253,   254,   255,
     256,   257,   943,   944,   286,   289,   947,   948,   289,   276,
     276,   289,   953,   289,   276,   290,   289,   289,   797,   274,
     274,   274,   274,   964,   281,     3,     4,   274,   969,     7,
     289,   281,   281,   281,   276,   276,   977,   277,   674,   274,
     274,    19,    20,    21,    22,    23,    24,   274,   274,   294,
     991,   290,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,   843,   290,   290,   846,   847,   848,
     290,   860,   851,   268,   269,   270,   865,   268,   269,   270,
     274,   860,   290,   288,   294,   294,   865,   294,   260,   274,
     288,   268,   269,   270,   803,   281,   274,   287,   293,   274,
     295,   274,   293,   892,   274,   894,   895,   896,   274,   289,
     260,   290,   274,   892,   274,   894,   895,   896,   268,   269,
     270,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,   290,     6,   924,   288,   268,   269,   270,
     289,   274,   261,   290,   274,   924,   274,   274,   784,   274,
     290,   290,   290,   287,   943,   944,   274,   274,   947,   948,
     289,   940,   274,   274,   943,   944,   286,   946,   947,   948,
      42,    43,    44,    45,    46,    47,    48,   290,   274,   958,
     969,     6,   274,   274,   274,     0,   965,   274,   274,   274,
     969,     6,   276,   274,   973,   974,   975,   274,   274,   978,
     274,   290,   274,   982,   274,   288,   985,   274,   277,   291,
     290,   990,   274,   333,   334,   335,   336,   337,   338,   339,
     340,   274,   342,   343,   287,   345,   274,    42,    43,    44,
      45,    46,    47,    48,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,   238,   239,   240,   241,   242,   243,
     244,   245,    42,    43,    44,    45,    46,    47,    48,   289,
     289,   274,   290,   274,   274,   287,   287,   274,   274,   287,
     274,   290,   274,   290,     6,   274,   274,   274,     6,   274,
      15,   277,   274,   274,   274,   274,    48,    51,   689,   277,
     268,   269,   270,   496,   360,   273,   793,   275,   650,   791,
     361,   464,    -1,   574,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,   296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   469,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     480,   481,    -1,   483,   484,   485,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   522,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   298,   299,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,   300,   301,   303,   304,   306,   308,
     309,   310,   311,   312,   313,   314,     3,     4,     5,   273,
     302,   275,   302,   275,   275,   275,   302,   275,   275,   275,
       6,    42,    43,    44,    45,    46,    47,    48,   315,   316,
     317,   318,   319,   300,     3,   274,     8,   307,     7,     7,
       8,     7,     7,     7,   278,   316,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   323,   339,   341,   343,   345,   347,
     349,   351,   353,   354,   355,   356,   358,   359,   360,   362,
     363,   364,   365,   372,   381,   389,   395,   397,   399,   400,
     401,   402,   403,   404,   405,   406,   408,   409,   413,   414,
     415,   416,   417,   418,   419,   420,   423,   426,   317,   302,
     276,   275,   305,   276,   276,   276,   276,   276,   276,   324,
     325,   326,   281,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   281,   269,   268,   281,   281,   281,
     281,   281,   361,   382,   383,   385,   384,   390,   391,   393,
     392,   398,   386,   394,   396,   387,   424,   425,     7,    23,
      25,    26,    27,    28,    29,   268,   269,   270,   293,   428,
     430,   431,   432,   443,   432,   281,   432,   432,   432,   281,
     366,   367,   367,   281,   373,   281,   375,   373,   373,   375,
     373,   373,   373,   281,   274,   302,     8,     6,     6,     6,
     270,   279,   320,   320,   320,     3,     4,   273,   449,   320,
     320,   280,   322,   322,   322,   320,   322,   322,   322,   320,
     320,   271,   274,   274,   272,   272,   272,   272,   272,   432,
     375,   375,   375,   375,   375,   375,   375,   375,   288,   375,
     375,   373,   375,   281,   421,   422,   422,   287,   287,   431,
     428,   274,   274,   274,   252,   253,   254,   255,   256,   257,
     357,   274,   274,   274,   250,   258,   261,   264,   282,   283,
     284,   285,   367,   432,   275,   370,   246,   247,   281,   374,
     238,   239,   240,   241,   242,   243,   244,   245,   451,   374,
     374,   374,   432,   374,   374,   374,   262,   302,   274,   276,
     275,   275,   277,   270,   274,   274,   274,     3,     4,   327,
     274,   274,     6,   449,   342,   344,   346,   348,   350,   352,
     274,   432,   432,   432,   432,   288,   288,   291,   284,   289,
     432,   291,   374,   432,   288,   291,   292,   293,   422,   268,
     268,     7,     8,    19,    20,    21,    22,    23,    24,   268,
     269,   270,   275,   293,   295,   296,   340,   427,   429,   433,
     434,   435,   436,   437,   438,   442,   444,   445,   446,   449,
     340,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,   275,   296,   434,   438,   439,   447,   448,
     449,   432,   439,   438,   439,   274,   451,   432,   248,   249,
     250,   251,   375,   432,   375,   375,   375,   375,   375,   281,
     302,     6,     6,   449,   322,   270,   279,   321,   321,   322,
     322,   322,   432,   340,   340,   432,   432,   432,   434,   435,
     440,   445,   447,   274,   274,   274,   274,   289,   289,   289,
     289,   427,   274,   289,   375,   274,   273,   286,   441,   441,
     287,   287,     5,   266,   267,   273,   449,   450,   287,   287,
     275,   434,   427,   429,   445,   449,   275,   448,   447,   274,
     274,   274,   435,   276,   274,   281,   274,   281,   281,   281,
     281,   281,   379,   449,   274,   277,   277,   274,   270,   274,
     274,   274,   274,   274,   274,   288,   288,   291,   284,   427,
     427,   427,   427,   286,   376,   377,   441,   291,   427,   281,
     291,   449,   449,   294,   294,   268,   268,   276,   276,     5,
     276,   276,   268,   268,   449,   450,   276,   449,   439,   439,
     434,   437,   259,   260,   368,   369,   435,   379,   288,   379,
     379,   379,   379,   379,   281,   302,   449,   449,     6,   322,
     322,   432,   435,   432,   437,   289,   289,   289,   289,   376,
     286,   380,   286,   378,   441,   378,   427,   290,   289,   378,
     379,   289,   441,   441,   441,   441,   276,   276,   276,   274,
     274,   274,   274,   281,   289,   432,   407,   281,   281,   281,
     263,   264,   265,   411,   274,   276,   276,   277,   274,   274,
     274,   274,   427,   427,   427,   427,   290,   275,   427,   290,
     427,   290,   290,   274,   427,   290,   288,   449,   294,   294,
     294,   294,   439,   438,   369,   368,   369,   435,   288,   291,
     412,   427,   449,   274,   288,   411,   411,   411,   281,   410,
     410,   410,   432,   302,   449,   435,   435,   432,   440,   377,
     380,   377,   377,   274,   427,   287,   274,   274,   274,   379,
     377,   274,   289,   290,   274,   274,   432,   432,   290,   288,
     289,   432,   435,   432,   261,   274,   274,   274,   274,   274,
     290,   290,   290,   290,   427,   441,   287,   427,   427,   427,
     290,   427,   447,   388,   369,   371,   435,   368,   369,   435,
     274,   274,   289,   412,   274,   274,   274,   412,     6,   435,
     435,   432,   274,   274,   274,   274,   274,   276,   449,   274,
     274,   274,   274,   274,   290,   274,   274,   288,   291,   412,
     290,   412,   412,   412,   274,   277,   274,   274,   447,   447,
     447,   447,   447,   287,   441,   447,   447,   447,   447,   447,
     274,   447,   369,   289,   289,   290,   274,   274,   274,   412,
     449,   435,   435,   287,   287,   427,   412,   412,   274,   427,
     412,   412,   274,   449,   287,   274,   290,   290,   427,   274,
       6,   449,   427,   274,   274,   274,   412,   277,   274,   427,
     427,   427,   274,   449,   427,   274,   427,   274,   427,     6,
     274,   277,   427,   449
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   297,   299,   298,   300,   300,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   301,   302,   302,   302,   302,
     303,   304,   305,   305,   307,   306,   308,   309,   310,   311,
     312,   313,   314,   315,   315,   315,   315,   315,   315,   315,
     316,   316,   317,   317,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   319,   320,   320,   321,   321,   322,   322,
     323,   324,   323,   325,   323,   326,   323,   327,   323,   328,
     323,   329,   323,   330,   323,   331,   323,   332,   323,   323,
     333,   323,   323,   323,   323,   323,   323,   323,   334,   323,
     323,   323,   323,   323,   335,   323,   323,   336,   323,   323,
     337,   323,   338,   323,   323,   339,   339,   340,   340,   342,
     341,   344,   343,   346,   345,   348,   347,   350,   349,   352,
     351,   353,   353,   353,   353,   353,   353,   353,   353,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   355,   355,   355,   355,   355,   355,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   357,   357,   357,   357,   357,
     357,   358,   358,   358,   359,   359,   359,   359,   359,   359,
     359,   359,   359,   359,   359,   359,   359,   359,   359,   359,
     360,   361,   360,   362,   362,   362,   362,   362,   362,   362,
     362,   362,   362,   363,   364,   364,   365,   365,   365,   365,
     365,   365,   365,   365,   365,   365,   365,   365,   365,   365,
     365,   365,   365,   365,   365,   365,   365,   365,   365,   365,
     365,   365,   366,   366,   366,   366,   366,   366,   366,   366,
     367,   367,   368,   369,   370,   371,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   373,   373,   374,   374,   374,   374,   375,   376,   377,
     377,   378,   378,   379,   380,   380,   382,   381,   383,   381,
     384,   381,   385,   381,   386,   381,   387,   388,   381,   390,
     389,   391,   389,   392,   389,   393,   389,   394,   389,   396,
     395,   398,   397,   399,   399,   399,   399,   399,   399,   399,
     399,   399,   399,   399,   400,   401,   402,   402,   403,   404,
     405,   406,   406,   407,   406,   408,   408,   409,   410,   410,
     411,   411,   411,   412,   412,   413,   414,   414,   414,   414,
     414,   414,   414,   414,   414,   414,   414,   414,   415,   416,
     416,   416,   417,   418,   419,   419,   419,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   421,   421,   421,
     421,   422,   422,   424,   423,   425,   423,   426,   427,   427,
     427,   427,   428,   428,   428,   428,   429,   430,   430,   430,
     430,   430,   431,   431,   432,   432,   433,   433,   433,   433,
     434,   434,   435,   435,   436,   436,   437,   437,   438,   438,
     438,   439,   439,   439,   440,   440,   440,   441,   441,   441,
     442,   442,   443,   443,   444,   444,   445,   445,   446,   446,
     446,   446,   446,   446,   446,   447,   447,   447,   447,   447,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   449,   449,   449,   449,   450,   450,   451,   451,
     451,   451,   451,   451,   451,   451
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       6,    11,     0,     3,     0,     4,     4,     4,     4,     2,
      10,    10,    23,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     2,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     1,     2,     1,     2,     2,
       1,     0,     5,     0,     7,     0,     7,     0,     5,     0,
       5,     0,     5,     0,     3,     0,     3,     0,     3,     1,
       0,     3,     1,     1,     1,     1,     1,     1,     0,     3,
       1,     1,     1,     1,     0,     3,     1,     0,     3,     1,
       0,     3,     0,     3,     1,     3,     3,     1,     1,     0,
       5,     0,     5,     0,     5,     0,    11,     0,    13,     0,
      13,     1,     1,     1,     1,     1,     1,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     8,     6,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       8,     0,     9,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     1,     1,     3,     1,     5,    10,    12,    10,
      10,     8,    10,    10,     8,     8,     6,     8,     6,     6,
       4,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     1,     2,     1,     8,     9,     0,    12,     0,    12,
       0,    12,     0,    12,     0,    12,     0,     0,    12,     0,
      12,     0,    12,     0,    12,     0,    12,     0,    12,     0,
      17,     0,     9,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,    20,    16,     1,     1,     1,     1,
       1,     9,    16,     0,    17,     1,     1,     3,     0,     2,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,    11,
      13,    13,     1,    12,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     0,     2,     0,     3,     0,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       2,     1,     2,     1,     1,     1,     1,     0,     2,     2,
       5,     5,     5,     5,     5,     5,     1,     1,     1,     3,
       3,     4,     4,     3,     3,     1,     3,     1,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 643 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 2910 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 16: /* const_val: T_FLOAT  */
#line 659 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 2916 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 17: /* const_val: T_INT  */
#line 660 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 2922 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: '-' T_INT  */
#line 661 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 2928 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_HEX  */
#line 662 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 2934 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 664 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 2944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 670 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 2952 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 675 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 2965 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* $@2: %empty  */
#line 684 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 2975 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 690 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 2985 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 27: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 696 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 2996 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 703 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3008 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 711 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3014 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 714 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3020 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 716 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3026 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 723 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3032 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* iflag: T_SY  */
#line 725 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3038 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* iflag: T_SS  */
#line 726 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3044 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* iflag: T_JP  */
#line 727 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3050 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* iflag: T_SAT  */
#line 728 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3056 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* iflag: T_RPT  */
#line 729 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3062 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_UL  */
#line 730 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3068 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_NOP  */
#line 731 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3074 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 49: /* instr: iflags cat5_instr  */
#line 744 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3080 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 53: /* label: T_IDENTIFIER ':'  */
#line 749 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3086 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 54: /* cat0_src1: '!' T_P0  */
#line 751 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3092 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 55: /* cat0_src1: T_P0  */
#line 752 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3098 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 56: /* cat0_src2: '!' T_P0  */
#line 754 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3104 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 57: /* cat0_src2: T_P0  */
#line 755 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3110 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 58: /* cat0_immed: '#' integer  */
#line 757 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3116 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 59: /* cat0_immed: '#' T_IDENTIFIER  */
#line 758 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3122 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 60: /* cat0_instr: T_OP_NOP  */
#line 760 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3128 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* $@3: %empty  */
#line 761 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3134 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* $@4: %empty  */
#line 762 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3140 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* $@5: %empty  */
#line 763 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3146 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* $@6: %empty  */
#line 764 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3152 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* $@7: %empty  */
#line 765 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3158 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* $@8: %empty  */
#line 766 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3164 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@9: %empty  */
#line 767 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3170 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@10: %empty  */
#line 768 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3176 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@11: %empty  */
#line 769 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3182 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* cat0_instr: T_OP_RET  */
#line 770 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3188 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 80: /* $@12: %empty  */
#line 771 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3194 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 82: /* cat0_instr: T_OP_END  */
#line 772 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3200 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* cat0_instr: T_OP_EMIT  */
#line 773 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3206 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 84: /* cat0_instr: T_OP_CUT  */
#line 774 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3212 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* cat0_instr: T_OP_CHMASK  */
#line 775 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3218 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 86: /* cat0_instr: T_OP_CHSH  */
#line 776 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3224 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* cat0_instr: T_OP_FLOW_REV  */
#line 777 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3230 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* $@13: %empty  */
#line 778 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3236 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_STKS  */
#line 779 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3242 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_STKR  */
#line 780 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3248 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* cat0_instr: T_OP_XSET  */
#line 781 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3254 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_XCLR  */
#line 782 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3260 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* $@14: %empty  */
#line 783 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3266 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_DBG  */
#line 784 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3272 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* $@15: %empty  */
#line 785 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3278 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_SHPE  */
#line 786 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3284 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* $@16: %empty  */
#line 787 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3290 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* $@17: %empty  */
#line 788 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3296 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* cat0_instr: T_OP_PREDE  */
#line 789 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3302 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 791 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 794 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 109: /* $@18: %empty  */
#line 801 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                       instr->repeat = (yyvsp[0].num) - 1;
                   }
#line 3329 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@18 dst_reg  */
#line 806 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       instr->dsts[0]->wrmask = (1 << (yyvsp[-2].num)) - 1;
                   }
#line 3337 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 111: /* $@19: %empty  */
#line 810 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* $@20: %empty  */
#line 817 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3359 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* $@21: %empty  */
#line 824 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3365 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 117: /* $@22: %empty  */
#line 826 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3371 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* $@23: %empty  */
#line 828 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3377 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 129: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 840 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3383 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 130: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3389 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 131: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3395 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 132: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 843 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3401 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 133: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3407 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 134: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3413 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 135: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 846 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3419 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 136: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 847 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3425 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 137: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3431 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3437 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_NOT_B  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3443 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3449 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_SETRM  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3455 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3461 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3467 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3473 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3479 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3485 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3491 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3497 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_2src: T_OP_ADD_F  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3503 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_2src: T_OP_MIN_F  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3509 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_2src: T_OP_MAX_F  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3515 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_2src: T_OP_MUL_F  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3521 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src: T_OP_ADD_U  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3527 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src: T_OP_ADD_S  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3533 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src: T_OP_SUB_U  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3539 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src: T_OP_SUB_S  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3545 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src: T_OP_MIN_U  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3551 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src: T_OP_MIN_S  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3557 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_MAX_U  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3563 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MAX_S  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3569 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_AND_B  */
#line 874 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3575 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_OR_B  */
#line 875 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3581 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_XOR_B  */
#line 876 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3587 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3593 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 878 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3599 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_MULL_U  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3605 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_SHL_B  */
#line 880 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3611 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_SHR_B  */
#line 881 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3617 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3623 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_BARY_F  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3629 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 884 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3635 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3641 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_SHB  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3647 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MSAD  */
#line 887 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3653 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cond: T_LT  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3659 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cond: T_LE  */
#line 890 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3665 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cond: T_GT  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3671 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cond: T_GE  */
#line 892 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3677 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cond: T_EQ  */
#line 893 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3683 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cond: T_NE  */
#line 894 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3689 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat3_opc: T_OP_MAD_U16  */
#line 900 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 3695 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat3_opc: T_OP_MADSH_U16  */
#line 901 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 3701 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cat3_opc: T_OP_MAD_S16  */
#line 902 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 3707 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cat3_opc: T_OP_MADSH_M16  */
#line 903 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 3713 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cat3_opc: T_OP_MAD_U24  */
#line 904 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 3719 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cat3_opc: T_OP_MAD_S24  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 3725 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cat3_opc: T_OP_MAD_F16  */
#line 906 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 3731 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cat3_opc: T_OP_MAD_F32  */
#line 907 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 3737 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 192: /* cat3_opc: T_OP_SEL_B16  */
#line 908 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 3743 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cat3_opc: T_OP_SEL_B32  */
#line 909 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 3749 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat3_opc: T_OP_SEL_S16  */
#line 910 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 3755 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_opc: T_OP_SEL_S32  */
#line 911 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 3761 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_opc: T_OP_SEL_F16  */
#line 912 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 3767 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_opc: T_OP_SEL_F32  */
#line 913 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 3773 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_opc: T_OP_SAD_S16  */
#line 914 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 3779 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_SAD_S32  */
#line 915 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 3785 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* $@24: %empty  */
#line 918 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_SHLG_B16); }
#line 3791 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat4_opc: T_OP_RCP  */
#line 920 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 3797 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat4_opc: T_OP_RSQ  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 3803 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat4_opc: T_OP_LOG2  */
#line 922 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 3809 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat4_opc: T_OP_EXP2  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 3815 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat4_opc: T_OP_SIN  */
#line 924 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 3821 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat4_opc: T_OP_COS  */
#line 925 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 3827 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat4_opc: T_OP_SQRT  */
#line 926 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 3833 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat4_opc: T_OP_HRSQ  */
#line 927 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 3839 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat4_opc: T_OP_HLOG2  */
#line 928 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 3845 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat4_opc: T_OP_HEXP2  */
#line 929 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 3851 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 933 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 3857 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 3863 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat5_opc: T_OP_ISAM  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 3869 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat5_opc: T_OP_ISAML  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 3875 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat5_opc: T_OP_ISAMM  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 3881 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat5_opc: T_OP_SAM  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 3887 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat5_opc: T_OP_SAMB  */
#line 940 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 3893 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat5_opc: T_OP_SAML  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 3899 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat5_opc: T_OP_SAMGQ  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 3905 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat5_opc: T_OP_GETLOD  */
#line 943 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 3911 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 224: /* cat5_opc: T_OP_CONV  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 3917 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 225: /* cat5_opc: T_OP_CONVM  */
#line 945 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 3923 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat5_opc: T_OP_GETSIZE  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 3929 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat5_opc: T_OP_GETBUF  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 3935 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat5_opc: T_OP_GETPOS  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 3941 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat5_opc: T_OP_GETINFO  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 3947 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat5_opc: T_OP_DSX  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 3953 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat5_opc: T_OP_DSY  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 3959 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat5_opc: T_OP_GATHER4R  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 3965 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat5_opc: T_OP_GATHER4G  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 3971 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat5_opc: T_OP_GATHER4B  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 3977 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat5_opc: T_OP_GATHER4A  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 3983 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat5_opc: T_OP_SAMGP0  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 3989 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat5_opc: T_OP_SAMGP1  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 3995 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat5_opc: T_OP_SAMGP2  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4001 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc: T_OP_SAMGP3  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4007 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc: T_OP_RGETPOS  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4013 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_RGETINFO  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4019 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_flag: '.' T_3D  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4025 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_flag: '.' 'a'  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4031 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_flag: '.' 'o'  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4037 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_flag: '.' 'p'  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4043 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_flag: '.' 's'  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4049 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_flag: '.' T_S2EN  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4055 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_flag: '.' T_NONUNIFORM  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_flag: '.' T_BASE  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_samp: T_SAMP  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4073 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_tex: T_TEX  */
#line 975 "../src/freedreno/ir3/ir3_parser.y"
                                  { if (instr->flags & IR3_INSTR_B) instr->cat5.samp |= ((yyvsp[0].tok) << 4); else instr->cat5.tex = (yyvsp[0].tok); }
#line 4079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_type: '(' type ')'  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_a1: src_reg  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat6_typed: '.' T_UNTYPED  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat6_typed: '.' T_TYPED  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat6_dim: '.' T_1D  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4109 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat6_dim: '.' T_2D  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4115 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat6_dim: '.' T_3D  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat6_dim: '.' T_4D  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4127 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat6_type: '.' type  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4133 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat6_imm_offset: offset  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4139 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat6_dst_offset: offset  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4145 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* cat6_dst_offset: '+' src  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->flags |= IR3_INSTR_G; }
#line 4151 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat6_immed: integer  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat6_stg_ldg_a6xx_offset: '+' '(' src offset ')' '<' '<' integer  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                                           {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                    }
#line 4167 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat6_stg_ldg_a6xx_offset: '+' src '<' '<' integer offset '<' '<' integer  */
#line 1018 "../src/freedreno/ir3/ir3_parser.y"
                                                                  {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                    }
#line 4177 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* $@25: %empty  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4183 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 288: /* $@26: %empty  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4189 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 290: /* $@27: %empty  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4195 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 292: /* $@28: %empty  */
#line 1027 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4201 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 294: /* $@29: %empty  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4207 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 296: /* $@30: %empty  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4213 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 297: /* $@31: %empty  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4221 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 299: /* $@32: %empty  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4227 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 301: /* $@33: %empty  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4233 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 303: /* $@34: %empty  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4239 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 305: /* $@35: %empty  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4245 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* $@36: %empty  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4251 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* $@37: %empty  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4257 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 311: /* $@38: %empty  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4263 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4269 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4275 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 315: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4281 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4287 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4293 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 318: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4299 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 319: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4305 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4311 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4317 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4323 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4329 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* cat6_atomic_g: cat6_atomic_opc cat6_typed cat6_dim cat6_type '.' cat6_immed '.' 'g' dst_reg ',' 'g' '[' cat6_reg_or_immed ']' ',' src ',' src ',' src  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                          {
                       instr->flags |= IR3_INSTR_G;
                   }
#line 4337 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4343 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4349 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 330: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4355 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* $@39: %empty  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4361 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* cat6_id_opc: T_OP_GETSPID  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4367 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* cat6_id_opc: T_OP_GETWID  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4373 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 339: /* cat6_bindless_base: '.' T_BASE  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4379 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 342: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1087 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4385 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 344: /* cat6_reg_or_immed: integer  */
#line 1090 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4391 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 345: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1092 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4397 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 346: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_ADD)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4403 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_SUB)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4409 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 348: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1096 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_XCHG)->flags |= IR3_INSTR_G; dummy_dst(); }
#line 4415 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_INC)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4421 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 350: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_DEC)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4427 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1099 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_CMPXCHG)->flags |= IR3_INSTR_G; dummy_dst(); }
#line 4433 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1100 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_MIN)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4439 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1101 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_MAX)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4445 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1102 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_AND)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4451 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1103 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_OR)->flags   |= IR3_INSTR_G; dummy_dst(); }
#line 4457 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1104 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_XOR)->flags  |= IR3_INSTR_G; dummy_dst(); }
#line 4463 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1105 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 4469 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1107 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 4475 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 4481 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1111 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 4487 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1113 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 4493 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                {
                      instr->cat6.d = (yyvsp[-9].tok);
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 4504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_todo: T_OP_G2L  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 4510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_todo: T_OP_L2G  */
#line 1123 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 4516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_todo: T_OP_RESFMT  */
#line 1124 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 4522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat7_scope: '.' 'w'  */
#line 1137 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 4528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat7_scope: '.' 'r'  */
#line 1138 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 4534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat7_scope: '.' 'l'  */
#line 1139 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 4540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat7_scope: '.' 'g'  */
#line 1140 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 4546 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* $@40: %empty  */
#line 1145 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 4552 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* $@41: %empty  */
#line 1146 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 4558 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 388: /* src: T_REGISTER  */
#line 1150 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 4564 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 389: /* src: T_A0  */
#line 1151 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 4570 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 390: /* src: T_A1  */
#line 1152 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 4576 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* src: T_P0  */
#line 1153 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 4582 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 392: /* dst: T_REGISTER  */
#line 1155 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 4588 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 393: /* dst: T_A0  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 4594 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* dst: T_A1  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 4600 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* dst: T_P0  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 4606 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 396: /* const: T_CONSTANT  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 4612 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 397: /* dst_reg_flag: T_EVEN  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 4618 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* dst_reg_flag: T_POS_INFINITY  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 4624 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1164 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 4630 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* dst_reg_flag: T_EI  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 4636 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* dst_reg_flag: T_WRMASK  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 4642 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 404: /* dst_reg: dst  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4648 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* dst_reg: dst_reg_flags dst  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4654 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* src_reg_flag: T_ABSNEG  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 4660 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* src_reg_flag: T_NEG  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 4666 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* src_reg_flag: T_ABS  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 4672 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 409: /* src_reg_flag: T_R  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 4678 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* offset: %empty  */
#line 1204 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 4684 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* offset: '+' integer  */
#line 1205 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 4690 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* offset: '-' integer  */
#line 1206 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 4696 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1208 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4702 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4708 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4714 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1212 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4720 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1214 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 4726 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1215 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4732 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* immediate_cat1: integer  */
#line 1224 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 4738 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* immediate_cat1: '(' integer ')'  */
#line 1225 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4744 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* immediate_cat1: '(' float ')'  */
#line 1226 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 4750 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1227 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 4756 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 442: /* immediate_cat1: 'h' '(' float ')'  */
#line 1228 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 4762 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 443: /* immediate_cat1: '(' T_NAN ')'  */
#line 1229 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 4768 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 444: /* immediate_cat1: '(' T_INF ')'  */
#line 1230 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 4774 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 445: /* immediate: integer  */
#line 1232 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4780 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 446: /* immediate: '(' integer ')'  */
#line 1233 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4786 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 447: /* immediate: flut_immed  */
#line 1234 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 4792 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 448: /* immediate: 'h' '(' integer ')'  */
#line 1235 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 4798 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 449: /* immediate: 'h' flut_immed  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 4804 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* integer: T_INT  */
#line 1252 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 4810 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 463: /* integer: '-' T_INT  */
#line 1253 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 4816 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 464: /* integer: T_HEX  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 4822 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 465: /* integer: '-' T_HEX  */
#line 1255 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 4828 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* float: T_FLOAT  */
#line 1257 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 4834 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 467: /* float: '-' T_FLOAT  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 4840 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 468: /* type: T_TYPE_F16  */
#line 1260 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 4846 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 469: /* type: T_TYPE_F32  */
#line 1261 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 4852 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* type: T_TYPE_U16  */
#line 1262 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 4858 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* type: T_TYPE_U32  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 4864 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* type: T_TYPE_S16  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 4870 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* type: T_TYPE_S32  */
#line 1265 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 4876 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* type: T_TYPE_U8  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 4882 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* type: T_TYPE_S8  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 4888 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 4892 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

